/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.motorcontrol;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.af3.platform.language.executable.ExecutableBase;
import org.fortiss.af3.platform.raspberry.generator.executable.framework.ISingletonInitializationExecutable;

/**
 * {@link ExecutableBase} base class for motor controller elements.
 * 
 * @author hoelzl
 */
abstract class MotorControlExecutableBase<T extends EObject> extends ExecutableBase<T> implements
		ISingletonInitializationExecutable {
	/** Constructor. */
	public MotorControlExecutableBase(T modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	@Override
	public final String getSingletonIdentifier() {
		return "vesc.h";
	}

	/** {@inheritDoc} */
	@Override
	public final String getSingletonVariableDeclarationCode(String singletonPostfix) {
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public final String getSingletonAuxiliaryFunctions(String singletonPostfix) {
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public final String getSingletonInitializationCode(String singletonPostfix) {
		return "initUSB(\"/dev/vesc\", B115200);\n";
	}
}
